#define F_CPU 4000000
#include <avr/io.h>
#include <avr/interrupt.h>
#include "nec.h"
#include "lcd-routines.h"
#include <util/delay.h>
#include <stdlib.h>

int main (void)
{
    DDRD |= (1<<PD6);
    PORTD &= ~(1<<PD6);

    lcd_init();
	char buffer[65];

    sei();
    ir_init();

	uint16_t addr;
	uint8_t cmd, cmd_inv;

    while(1)
    {
		if(addr != getAddr() && getAddr() != 0)
			addr = getAddr();

		if(cmd != getCmd() && getCmd() != 0)
			cmd = getCmd();

		if(cmd_inv != getCmdInv() && getCmdInv() != 0)
			cmd_inv = getCmdInv();

		lcd_clear();
		lcd_home();

		lcd_string("Adresse:");
		itoa(addr, buffer, 16);
		set_cursor(0,1);
		lcd_string(buffer);

		set_cursor(0,2);
		lcd_string("Cmd:");
		itoa(cmd, buffer, 2);
		set_cursor(0,3);
		lcd_string(buffer);


		set_cursor(19,2);
		lcd_string("Cmd invertiert:");
		itoa(cmd_inv, buffer, 2);
		set_cursor(19,3);
		lcd_string(buffer);

		_delay_ms(500);
    }

	return 0;
}
