#include "nec.h"

uint8_t impulse = 0;
uint8_t impulse_prev = 0;
uint8_t counter_impulse_1 = 0;
uint8_t counter_impulse_0 = 0;
int8_t counter_ik = -1;
uint8_t flag_rx = 0;
uint16_t addr;
uint8_t cmd, cmd_inv;

uint16_t getAddr (void)
{
   return addr;
}

uint8_t getCmd (void)
{
   return cmd;
}

uint8_t getCmdInv (void)
{
   return cmd_inv;
}

void ir_init (void)
{
    IR_DDR &= ~(1<<IR);   // configure IR-Pin as input
    IR_PORT &= ~(1<<IR);

    TCCR0 |= (1<<CS00);      // start timer without prescaler
    TIMSK |= (1<<TOIE0);     // enable interrupt on timer0 overflow
}

ISR (TIMER0_OVF_vect)
{
    //PORTD ^= (1<<PD6);
    //Timer0 initialization
    TCNT0=0x00;

    //Invert input signal
    if (IR_PIN & (1<<IR)) impulse=0;
    else impulse=1;

    if ((impulse_prev==0)&&(impulse==1)) //rising edge detection
    {
		if (counter_impulse_1>100 && counter_impulse_0>50)   //9ms high & 4.5ms low - starting condition
        {
            cmd=0;
			cmd_inv=0;
			addr=0;
            counter_ik=-1;
            flag_rx=1;
			counter_impulse_0=0;
			counter_impulse_1=0;
            //PORTD ^= (1<<PD6);
        }

        counter_impulse_1=0;  //reset counter
        if ((counter_impulse_0>10)&&(flag_rx==1)&&(counter_impulse_0<50))  //if receiving symbols
        {
			if (counter_ik >= 0 && counter_ik <= 15)
				addr |= (1 << counter_ik);
			else if (counter_ik >= 16 && counter_ik <= 23)
				cmd |= (1 << (counter_ik-16));
			else if (counter_ik >= 24 && counter_ik <= 31)
				cmd_inv |= (1 << (counter_ik-24));
        }
		counter_ik++;
		counter_impulse_0=0;
    }

    if ((impulse==1)&&(counter_impulse_1<250))   //counting positive pulses
        counter_impulse_1++;

    if ((impulse==0)&&(counter_impulse_1<250))   //counting negative pulses
        counter_impulse_0++;

    if ((counter_impulse_0>240)&&(flag_rx==1)&&(impulse==0))   //end of receive
        flag_rx=0;

    impulse_prev=impulse;
}
